From 3599146d59b50c18c3304e05fc2da5b2c30d86e5 Mon Sep 17 00:00:00 2001
From: Simon Arlott <sa.me.uk>
Date: Mon, 27 Aug 2012 21:48:09 +0100
Subject: [PATCH 2/2] automatically connect using IPv6 or IPv4

A failed server will cause the next group of hosts in
an address family to be used, until there are no more
groups of hosts and it starts again from the beginning.

The list of hosts within a group of the same address
family is randomly shuffled so that a different IP is
used if the resolver library returns the IPs in the
same order each time.

Under Cygwin a pool of sockets is used when making
connection attempts, otherwise the child process passes
the socket to the parent when connected.

The connect API is changed:
  Removed parameter "sock"
  Added parameter "retry"
  Added callback value "sock"
---
 doc/de/weechat_scripting.de.txt         |    3 +-
 doc/en/weechat_plugin_api.en.txt        |   13 +-
 doc/en/weechat_scripting.en.txt         |    3 +-
 doc/fr/weechat_plugin_api.fr.txt        |   11 +-
 doc/fr/weechat_scripting.fr.txt         |    3 +-
 doc/it/weechat_plugin_api.it.txt        |   11 +-
 doc/it/weechat_scripting.it.txt         |    3 +-
 doc/pl/weechat_scripting.pl.txt         |    3 +-
 src/core/wee-hook.c                     |   46 ++-
 src/core/wee-hook.h                     |   27 +-
 src/core/wee-network.c                  |  663 ++++++++++++++++++++-----------
 src/plugins/guile/weechat-guile-api.c   |   27 +-
 src/plugins/irc/irc-server.c            |  124 +++---
 src/plugins/irc/irc-server.h            |    5 +-
 src/plugins/lua/weechat-lua-api.c       |   35 ++-
 src/plugins/perl/weechat-perl-api.c     |   20 +-
 src/plugins/plugin-script-api.c         |    9 +-
 src/plugins/plugin-script-api.h         |    3 +-
 src/plugins/python/weechat-python-api.c |   26 +-
 src/plugins/python/weechat-python.c     |    1 +
 src/plugins/ruby/weechat-ruby-api.c     |   31 +-
 src/plugins/tcl/weechat-tcl-api.c       |   25 +-
 src/plugins/weechat-plugin.h            |   14 +-
 23 files changed, 718 insertions(+), 388 deletions(-)

diff --git a/src/core/wee-hook.c b/src/core/wee-hook.c
index 5080e7f..e5e19fd 100644
--- a/src/core/wee-hook.c
+++ b/src/core/wee-hook.c
@@ -1713,13 +1713,16 @@ hook_process_run (struct t_hook *hook_process)
 
 struct t_hook *
 hook_connect (struct t_weechat_plugin *plugin, const char *proxy,
-              const char *address, int port, int sock, int ipv6,
+              const char *address, int port, int ipv6, unsigned int retry,
               void *gnutls_sess, void *gnutls_cb, int gnutls_dhkey_size,
               const char *gnutls_priorities, const char *local_hostname,
               t_hook_callback_connect *callback, void *callback_data)
 {
     struct t_hook *new_hook;
     struct t_hook_connect *new_hook_connect;
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+    int i;
+#endif
 
 #ifndef HAVE_GNUTLS
     /* make C compiler happy */
@@ -1729,7 +1732,7 @@ hook_connect (struct t_weechat_plugin *plugin, const char *proxy,
     (void) gnutls_priorities;
 #endif
 
-    if ((sock < 0) || !address || (port <= 0) || !callback)
+    if (!address || (port <= 0) || !callback)
         return NULL;
 
     new_hook = malloc (sizeof (*new_hook));
@@ -1750,8 +1753,9 @@ hook_connect (struct t_weechat_plugin *plugin, const char *proxy,
     new_hook_connect->proxy = (proxy) ? strdup (proxy) : NULL;
     new_hook_connect->address = strdup (address);
     new_hook_connect->port = port;
-    new_hook_connect->sock = sock;
+    new_hook_connect->sock = -1;
     new_hook_connect->ipv6 = ipv6;
+    new_hook_connect->retry = retry;
 #ifdef HAVE_GNUTLS
     new_hook_connect->gnutls_sess = gnutls_sess;
     new_hook_connect->gnutls_cb = gnutls_cb;
@@ -1763,6 +1767,8 @@ hook_connect (struct t_weechat_plugin *plugin, const char *proxy,
         strdup (local_hostname) : NULL;
     new_hook_connect->child_read = -1;
     new_hook_connect->child_write = -1;
+    new_hook_connect->child_recv = -1;
+    new_hook_connect->child_send = -1;
     new_hook_connect->child_pid = 0;
     new_hook_connect->hook_child_timer = NULL;
     new_hook_connect->hook_fd = NULL;
@@ -1770,6 +1776,13 @@ hook_connect (struct t_weechat_plugin *plugin, const char *proxy,
     new_hook_connect->handshake_hook_timer = NULL;
     new_hook_connect->handshake_fd_flags = 0;
     new_hook_connect->handshake_ip_address = NULL;
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+    for (i = 0; i < HOOK_CONNECT_MAX_SOCKETS; i++)
+    {
+        new_hook_connect->sock_v4[i] = -1;
+        new_hook_connect->sock_v6[i] = -1;
+    }
+#endif
 
     hook_add_to_list (new_hook);
 
@@ -3166,6 +3179,19 @@ unhook (struct t_hook *hook)
                     close (HOOK_CONNECT(hook, child_read));
                 if (HOOK_CONNECT(hook, child_write) != -1)
                     close (HOOK_CONNECT(hook, child_write));
+                if (HOOK_CONNECT(hook, child_recv) != -1)
+                    close (HOOK_CONNECT(hook, child_recv));
+                if (HOOK_CONNECT(hook, child_send) != -1)
+                    close (HOOK_CONNECT(hook, child_send));
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+                for (i = 0; i < HOOK_CONNECT_MAX_SOCKETS; i++)
+                {
+                    if (HOOK_CONNECT(hook, sock_v4[i]) != -1)
+                        close (HOOK_CONNECT(hook, sock_v4[i]));
+                    if (HOOK_CONNECT(hook, sock_v6[i]) != -1)
+                        close (HOOK_CONNECT(hook, sock_v6[i]));
+                }
+#endif
                 break;
             case HOOK_TYPE_PRINT:
                 if (HOOK_PRINT(hook, message))
@@ -3478,6 +3504,8 @@ hook_add_to_infolist_type (struct t_infolist *infolist, int type,
                         return 0;
                     if (!infolist_new_var_integer (ptr_item, "ipv6", HOOK_CONNECT(ptr_hook, ipv6)))
                         return 0;
+                    if (!infolist_new_var_integer (ptr_item, "retry", HOOK_CONNECT(ptr_hook, retry)))
+                        return 0;
 #ifdef HAVE_GNUTLS
                     if (!infolist_new_var_pointer (ptr_item, "gnutls_sess", HOOK_CONNECT(ptr_hook, gnutls_sess)))
                         return 0;
@@ -3492,6 +3520,10 @@ hook_add_to_infolist_type (struct t_infolist *infolist, int type,
                         return 0;
                     if (!infolist_new_var_integer (ptr_item, "child_write", HOOK_CONNECT(ptr_hook, child_write)))
                         return 0;
+                    if (!infolist_new_var_integer (ptr_item, "child_recv", HOOK_CONNECT(ptr_hook, child_recv)))
+                        return 0;
+                    if (!infolist_new_var_integer (ptr_item, "child_send", HOOK_CONNECT(ptr_hook, child_send)))
+                        return 0;
                     if (!infolist_new_var_integer (ptr_item, "child_pid", HOOK_CONNECT(ptr_hook, child_pid)))
                         return 0;
                     if (!infolist_new_var_pointer (ptr_item, "hook_child_timer", HOOK_CONNECT(ptr_hook, hook_child_timer)))
@@ -3886,12 +3918,20 @@ hook_print_log ()
                         log_printf ("    port. . . . . . . . . : %d",    HOOK_CONNECT(ptr_hook, port));
                         log_printf ("    sock. . . . . . . . . : %d",    HOOK_CONNECT(ptr_hook, sock));
                         log_printf ("    ipv6. . . . . . . . . : %d",    HOOK_CONNECT(ptr_hook, ipv6));
+                        log_printf ("    retry . . . . . . . . : %u",    HOOK_CONNECT(ptr_hook, retry));
 #ifdef HAVE_GNUTLS
                         log_printf ("    gnutls_sess . . . . . : 0x%lx", HOOK_CONNECT(ptr_hook, gnutls_sess));
                         log_printf ("    gnutls_cb . . . . . . : 0x%lx", HOOK_CONNECT(ptr_hook, gnutls_cb));
                         log_printf ("    gnutls_dhkey_size . . : %d",    HOOK_CONNECT(ptr_hook, gnutls_dhkey_size));
                         log_printf ("    gnutls_priorities . . : '%s'",  HOOK_CONNECT(ptr_hook, gnutls_priorities));
 #endif
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+                        for (i = 0; i < HOOK_CONNECT_MAX_SOCKETS; i++)
+                        {
+                            log_printf ("    sock_v4[%d] . . . . . : '%d'",  HOOK_CONNECT(ptr_hook, sock_v4[i]));
+                            log_printf ("    sock_v6[%d] . . . . . : '%d'",  HOOK_CONNECT(ptr_hook, sock_v6[i]));
+                        }
+#endif
                         log_printf ("    local_hostname. . . . : '%s'",  HOOK_CONNECT(ptr_hook, local_hostname));
                         log_printf ("    child_read. . . . . . : %d",    HOOK_CONNECT(ptr_hook, child_read));
                         log_printf ("    child_write . . . . . : %d",    HOOK_CONNECT(ptr_hook, child_write));
diff --git a/src/core/wee-hook.h b/src/core/wee-hook.h
index c1375d3..f47b5df 100644
--- a/src/core/wee-hook.h
+++ b/src/core/wee-hook.h
@@ -26,6 +26,18 @@
 #include <gnutls/gnutls.h>
 #endif
 
+#ifdef __CYGWIN__
+/*
+ * For the connect hook, when this is defined an array of sockets will
+ * be passed from the parent process to the child process instead of using
+ * SCM_RIGHTS to pass a socket back from the child process to parent process.
+ *
+ * This allows connections to work on Windows but it limits the number of
+ * IPs that can be attempted each time.
+ */
+#define HOOK_CONNECT_MAX_SOCKETS 4
+#endif
+
 struct t_gui_bar;
 struct t_gui_buffer;
 struct t_gui_line;
@@ -212,7 +224,7 @@ struct t_hook_process
 /* hook connect */
 
 typedef int (t_hook_callback_connect)(void *data, int status,
-                                      int gnutls_rc,
+                                      int gnutls_rc, int sock,
                                       const char *error,
                                       const char *ip_address);
 
@@ -235,8 +247,9 @@ struct t_hook_connect
     char *proxy;                       /* proxy (optional)                  */
     char *address;                     /* peer address                      */
     int port;                          /* peer port                         */
-    int sock;                          /* socket (created by caller)        */
-    int ipv6;                          /* IPv6 connection ?                 */
+    int ipv6;                          /* use IPv6                          */
+    int sock;                          /* socket (set when connected)       */
+    unsigned int retry;                /* retry count                       */
 #ifdef HAVE_GNUTLS
     gnutls_session_t *gnutls_sess;     /* GnuTLS session (SSL connection)   */
     gnutls_callback_t *gnutls_cb;      /* GnuTLS callback during handshake  */
@@ -246,6 +259,8 @@ struct t_hook_connect
     char *local_hostname;              /* force local hostname (optional)   */
     int child_read;                    /* to read data in pipe from child   */
     int child_write;                   /* to write data in pipe for child   */
+    int child_recv;                    /* to read data from child socket    */
+    int child_send;                    /* to write data to child socket     */
     pid_t child_pid;                   /* pid of child process (connecting) */
     struct t_hook *hook_child_timer;   /* timer for child process timeout   */
     struct t_hook *hook_fd;            /* pointer to fd hook                */
@@ -253,6 +268,10 @@ struct t_hook_connect
     struct t_hook *handshake_hook_timer; /* timer for handshake timeout     */
     int handshake_fd_flags;            /* socket flags saved for handshake  */
     char *handshake_ip_address;        /* ip address (used for handshake)   */
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+    int sock_v4[HOOK_CONNECT_MAX_SOCKETS];  /* IPv4 sockets for connecting  */
+    int sock_v6[HOOK_CONNECT_MAX_SOCKETS];  /* IPv6 sockets for connecting  */
+#endif
 };
 
 /* hook print */
@@ -457,7 +476,7 @@ extern struct t_hook *hook_process_hashtable (struct t_weechat_plugin *plugin,
                                               void *callback_data);
 extern struct t_hook *hook_connect (struct t_weechat_plugin *plugin,
                                     const char *proxy, const char *address,
-                                    int port, int sock, int ipv6,
+                                    int port, int ipv6, unsigned int retry,
                                     void *gnutls_session, void *gnutls_cb,
                                     int gnutls_dhkey_size,
                                     const char *gnutls_priorities,
